
package jp.gr.java_conf.koto.notavacc;

import java.util.*;
import java.io.*;
import jp.gr.java_conf.koto.util.*;
import jp.gr.java_conf.koto.notavacc.parser.*;

public class Environment {
    public final Properties parameters;
    public final boolean withoutParentPath;
    public final boolean dryRun;
    public final boolean separateOutput;
    public final boolean experimental;
    public final Logger logger;
    public final CommandLineChecker commandLine;
    public final String sourceEncoding;
    public final String destinationEncoding;
    public File processingFile;
    public Environment(Logger logger, CommandLineChecker commandLine, String sourceEncoding, String destinationEncoding) {
        this.parameters = new Properties();
        this.withoutParentPath = commandLine.countOf("x-without-parent-path") > 0;
        this.dryRun = commandLine.countOf("dry-run") > 0;
        this.separateOutput = commandLine.countOf("x-separate-output") > 0;
        //this.experimental = true;
        this.experimental = commandLine.countOf("experimental") > 0;
        
        InputStream parametersStream = new BufferedInputStream(Environment.class.getResourceAsStream("parameters.properties"));
        try {
            parameters.load(parametersStream);
            parametersStream.close();
        } catch (IOException x) {
            throw new RuntimeException(x);
        }
        
        this.logger = logger;
        this.commandLine = commandLine;
        this.sourceEncoding = sourceEncoding;
        this.destinationEncoding = destinationEncoding;
    }
}

